#include <MKL25Z4.h>

#define RED_LIGHT_SHIFT (18)    // on port B
#define GREEN_LIGHT_SHIFT (19)  // on port B
#define BLUE_LIGHT_SHIFT (1)    // on port D

#define MASK(x) (1UL << (x))

void Delay(volatile unsigned int time_del)
{
	while (time_del--)
	{
		;
	}
}


void KL25Z_RGB_Flasher(void)
{
	// Enable the clock to Port B & Port D
	SIM_BASE_PTR->SCGC5 |= SIM_SCGC5_PORTB_MASK | SIM_SCGC5_PORTD_MASK;

	//Make 3 pins GPIO
	PORTB_BASE_PTR->PCR[RED_LIGHT_SHIFT] &= ~PORT_PCR_MUX_MASK;
	PORTB_BASE_PTR->PCR[RED_LIGHT_SHIFT] |= PORT_PCR_MUX(1);
	PORTB_BASE_PTR->PCR[GREEN_LIGHT_SHIFT] &= ~PORT_PCR_MUX_MASK;
	PORTB_BASE_PTR->PCR[GREEN_LIGHT_SHIFT] |= PORT_PCR_MUX(1);
	PORTD_BASE_PTR->PCR[BLUE_LIGHT_SHIFT] &= ~PORT_PCR_MUX_MASK;
	PORTD_BASE_PTR->PCR[BLUE_LIGHT_SHIFT] |= PORT_PCR_MUX(1);

	// Set ports to outputs
	PTB_BASE_PTR->PDDR |= MASK(RED_LIGHT_SHIFT) | MASK(GREEN_LIGHT_SHIFT);
	PTD_BASE_PTR->PDDR |= MASK(BLUE_LIGHT_SHIFT);

	// Turn on LEDs
	PTB_BASE_PTR->PCOR |= MASK(RED_LIGHT_SHIFT) | MASK(GREEN_LIGHT_SHIFT);
	PTD_BASE_PTR->PCOR |= MASK(BLUE_LIGHT_SHIFT);

	while (1)
	{
		for (int num = 0; num < 8; num++)
		{
			if (num & 1)
				PTB_BASE_PTR->PSOR = MASK(RED_LIGHT_SHIFT);

			else
				PTB_BASE_PTR->PCOR = MASK(RED_LIGHT_SHIFT);

			if (num & 2)
				PTB_BASE_PTR->PSOR = MASK(GREEN_LIGHT_SHIFT);

			else
				PTB_BASE_PTR->PCOR = MASK(GREEN_LIGHT_SHIFT);

			if (num & 4)
				PTB_BASE_PTR->PSOR = MASK(BLUE_LIGHT_SHIFT);

			else
				PTB_BASE_PTR->PCOR = MASK(BLUE_LIGHT_SHIFT);

			Delay(2000000);
		}
	}
}

